import {
  Component,
  OnInit,
  Output,
  EventEmitter
} from '@angular/core';
import { Anim } from './animation';
import { Service } from '@overflow/commons-typescript/model/discovery';

@Component({
  selector: 'of-discovery-search-filter',
  templateUrl: './search-filter.component.html',
  animations: Anim
})
export class SearchFilterComponent implements OnInit {

  services: Service[] = [];
  filterWord: string;
  filterServices = [];

  @Output() search = new EventEmitter<string>();
  @Output() serviceSelect = new EventEmitter<Service[]>();

  constructor(
  ) {
  }

  ngOnInit() {
  }

  onSearch(e) {
    if (e.key !== 'Enter') {
      return;
    }
    this.search.emit(this.filterWord);
  }

  addService(service: Service) {
    if (service.serviceName.indexOf('Not Supported Service') >= 0) {
      return;
    }
    let exist = false;
    this.services.forEach(value => {
      if (value.serviceName === service.serviceName) {
        exist = true;
        return;
      }
    });
    if (!exist) {
      this.services.push(service);
      this.filterServices.push(service);
    }
  }

  onServiceFilter(e, service: Service) {
    // if (e.checked) {
    //   this.filterServices.push(service);
    // } else {
    //   const index = this.filterServices.indexOf(service);
    //   this.filterServices.splice(index, 1);
    // }

    this.serviceSelect.emit(this.filterServices);
  }


  onSelectAll() {
    this.filterServices = [];
    this.services.forEach((value) => {
      this.filterServices.push(value);
    });
    this.serviceSelect.emit(this.filterServices);
  }

  onUnselectAll() {
    this.filterServices = [];
    this.serviceSelect.emit(this.filterServices);
  }

  onSelect(service: Service) {
    this.serviceSelect.emit(this.filterServices);
  }
  onUnselect(service: Service) {
    this.serviceSelect.emit(this.filterServices);
  }

}
